package PhotoPub::AlbumHelper;
require Exporter;
@ISA = qw(Exporter);
@EXPORT_OK = qw(&rangelink &dispimgwithdefaults &photodatestr);

use strict;

use PhotoPub::RangeHelper qw(&dispimg);
use PhotoPub::Handlers qw(&handlephoto);
use PhotoPub::Annots qw(&getannot);
use PhotoPub::Config qw(%linkroots);
use PhotoPub::Utils qw(&handletagoptions);

use POSIX qw(&strftime);

sub rangelink {
  my ($otheroptions,$queryprefix,$params,$styleroot)=@_;
  my $rangelinkroot=$linkroots{'range'};
  &handletagoptions(\$queryprefix,$styleroot,$params);
  return '<a'.$otheroptions.'href="'.$rangelinkroot
            .'?'.$queryprefix.'">';
}

sub dispimgwithdefaults($,$,$,$) {
  my ($other,$photo,$extra)=@_;
  &dispimg($other,$photo,&getannot($photo,'options'),$extra);
}

sub photodatestr {
  my ($photo,$options)=@_;
  my $whentaken=&handlephoto('whentaken',$photo);
  return '' unless defined $whentaken;
  my $format="%c";
  foreach my $attrpair ($options=~m/\w+\=\".*?\"/g) {
    if(my ($attr,$value) = split (/=/, $attrpair)) {
      if(lc($attr) eq 'format') {
	$value=~s/\"(.*)\"/$1/;
	$format=$value;
      }
    }
  }
  return &strftime($format,gmtime($whentaken));
}
