package PhotoPub::Images;
require Exporter;
@ISA = qw(Exporter);
@EXPORT_OK = qw(&picfile &picrange &canonicalname);

use strict;
no strict 'vars'; # until we break the recursive Config<->Images dependency

use PhotoPub::Global qw(&$error);
use PhotoPub::Config qw($defaultpath);
use PhotoPub::Handlers qw(&handlephoto &listhandlephoto &parameterhandlephoto);
use PhotoPub::Utils qw(&parserange);

sub picrange {
  my ($rangestr)=@_;
  my @photos=();
  my %checks=();
  &parserange($rangestr,$defaultpath,
	      sub {
		my ($path,$num)=@_;
		$checks{$path}=[] unless exists $checks{$path};
		push @{$checks{$path}},$num;
		return 1;
	      });
  foreach my $path (keys %checks) {
    my $validnums=&parameterhandlephoto('existsphotos',$path,$checks{$path});
    foreach my $num (@$validnums) {
      push @photos,($path.$num);
    }
  }
  return @photos;
}


sub picfile {
  my ($photo)=@_;
  return handlephoto('imagefile',$photo);
}

sub canonicalname {
  my ($photo)=@_;
  my $canonicalphoto=&handlephoto('canonicalname',$photo);
  $canonicalphoto=$photo unless defined $canonicalphoto;
  return $canonicalphoto;
}

1;
