#!/usr/bin/perl -wT

use lib '/usr/lib/photopub';

use strict;

use PhotoPub::Global qw(&init $error);
use PhotoPub::CGIBase qw(&usererror $query &printheader);
use PhotoPub::Config qw($defaultpath);
use PhotoPub::Images qw(&picfile);
use PhotoPub::Options qw(&initoptions &setoptions);
use PhotoPub::Cache qw(&imagefile);
use PhotoPub::Ages qw(&updateagefromfiles);
use PhotoPub::DisplayHelper qw(&checkimageoptions);

&init();

my $photo=$query->param('photo') or &usererror('Must give a photo!');

$photo=$defaultpath.'/'.$photo if substr($photo,0,1) ne '/';

my $image_options=&initoptions();

my $image_options_from_query=&checkimageoptions($query);

while(my ($entry,$value)=each %$image_options_from_query) {
  &setoptions($image_options,{$entry => $value});
}


updateagefromfiles($0);
my $outputfile=imagefile($photo,$image_options);

open PIC,"<$outputfile" 
  or &$error(type => 'config', 
	     message => "couldn't open $outputfile for reading");

# make expiry configurable on a per-path basis or something
printheader(-type => 'image/jpeg'); 

while(<PIC>) {
  print;
}

close PIC;
